'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fetchStates = require('../mapper/fetch-states');

var _fetchStates2 = _interopRequireDefault(_fetchStates);

var _httpMethods = require('../mapper/http-methods');

var _httpMethods2 = _interopRequireDefault(_httpMethods);

require('isomorphic-fetch');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FetchHttpLayer = function () {
  function FetchHttpLayer() {
    _classCallCheck(this, FetchHttpLayer);
  }

  _createClass(FetchHttpLayer, [{
    key: 'handleRequest',
    value: function handleRequest(stateDispatcher, request, method) {
      var beforeRequest = request.options.beforeRequest || function () {};
      var afterResponse = request.options.afterResponse || function () {};
      var parseResponse = request.options.parseResponse || request.options.responseParse || function (r) {
        return r.json();
      };
      var parseBody = request.options.parseBody || request.options.bodyParse || function (b) {
        return b ? JSON.stringify(b) : b;
      };
      var payload = request.options.payload || {};
      var cacheHandler = request.options.cacheHandler;
      var errorHandler = request.options.errorHandler || function (e) {
        return e;
      };
      var delay = request.options.delay;
      var memResponse = request.options.memResponse;
      var credentials = request.options.credentials;

      beforeRequest(request);
      stateDispatcher(_fetchStates2.default.FETCH_STARTED, payload);

      if (memResponse !== undefined) {
        var memResponseFn = typeof memResponse === "function" ? memResponse : function () {
          return memResponse;
        };

        return new Promise(function (resolve) {
          if (delay > 0) {
            stateDispatcher(_fetchStates2.default.FETCH_STARTED, payload);
            setTimeout(function () {
              var response = memResponseFn(request);

              stateDispatcher(_fetchStates2.default.FETCH_COMPLETED, _extends({}, payload, { data: response }));
              afterResponse(response);
              resolve(response);
            }, delay);
          } else {
            var response = memResponseFn(request);

            stateDispatcher(_fetchStates2.default.FETCH_COMPLETED, _extends({}, payload, { data: response }));
            afterResponse(response);
            resolve(response);
          }
        });
      }

      if (cacheHandler) {
        var cacheResponse = cacheHandler(request);

        if (cacheResponse !== undefined) {
          return new Promise(function (resolve) {
            stateDispatcher(_fetchStates2.default.FETCH_COMPLETED, _extends({}, payload, { data: cacheResponse }));
            afterResponse(cacheResponse);
            resolve(cacheResponse);
          });
        }
      }

      fetch(request.fullPath, {
        method: method,
        headers: request.headers,
        body: parseBody(request.body),
        credentials: credentials
      }).then(function (response) {
        return new Promise(function (resolve) {
          var hasError = response.status < 200 || response.status >= 300;

          parseResponse(response).then(function (parsedResponse) {
            afterResponse(request, parsedResponse);

            if (hasError) stateDispatcher(_fetchStates2.default.FETCH_ERROR, _extends({}, payload, { data: parsedResponse }));else stateDispatcher(_fetchStates2.default.FETCH_COMPLETED, _extends({}, payload, { data: parsedResponse }));

            resolve(parsedResponse);
          });
        });
      }).catch(function (e) {
        stateDispatcher(_fetchStates2.default.FETCH_ERROR, _extends({}, payload, { data: errorHandler(e) }));
      });
    }
  }, {
    key: 'get',
    value: function get(stateDispatcher, request) {
      return this.handleRequest(stateDispatcher, request, _httpMethods2.default.GET);
    }
  }, {
    key: 'post',
    value: function post(stateDispatcher, request) {
      return this.handleRequest(stateDispatcher, request, _httpMethods2.default.POST);
    }
  }, {
    key: 'put',
    value: function put(stateDispatcher, request) {
      return this.handleRequest(stateDispatcher, request, _httpMethods2.default.PUT);
    }
  }, {
    key: 'delete',
    value: function _delete(stateDispatcher, request) {
      return this.handleRequest(stateDispatcher, request, _httpMethods2.default.DELETE);
    }
  }, {
    key: 'patch',
    value: function patch(stateDispatcher, request) {
      return this.handleRequest(stateDispatcher, request, _httpMethods2.default.PATCH);
    }
  }, {
    key: 'head',
    value: function head(stateDispatcher, request) {
      return this.handleRequest(stateDispatcher, request, _httpMethods2.default.HEAD);
    }
  }]);

  return FetchHttpLayer;
}();

exports.default = FetchHttpLayer;