"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
function buildRequestPath(host, rPath, ePath, params) {
  return encodeURI("" + host + rPath + parseEndPointPath(ePath, params));
}

function parseEndPointPath(ePath, params) {
  if (!params) return ePath;

  var queryString = "";
  var tmpPath = ePath.slice();
  for (var param in params) {
    var reg = new RegExp("{" + param + "}");
    var newPath = tmpPath.replace(reg, params[param]);
    if (newPath === tmpPath) queryString = queryString ? queryString + ("&" + param + "=" + params[param]) : param + "=" + params[param];
    tmpPath = newPath;
  }
  return queryString ? tmpPath + '?' + queryString : tmpPath;
}

exports.default = buildRequestPath;